'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var graph = require('fbgraph');
var fs = require('fs');
var readline = require('readline');

/*

https://developers.facebook.com/tools/explorer
https://developers.facebook.com/tools/accesstoken/

https://developers.facebook.com/tools/debug/accesstoken/

*/

var facebookProvider = function facebookProvider(options) {

	//========DEFAULTS AND OPTIONS EXTENSIONS================
	var defaults = {
		appSecret: "",
		accessToken: "",
		tokenPath: "",
		appId: "",
		entityId: "me"
		//Set default parameters and default configurations
	};var extendDefaults = function extendDefaults(source, properties) {
		var property;
		for (property in properties) {
			if (properties.hasOwnProperty(property)) {
				source[property] = properties[property];
			}
		}
		return source;
	};
	if (arguments.length <= 0) {
		this.options = defaults;
	} else if (arguments[0] && _typeof(arguments[0]) === "object") {
		this.options = extendDefaults(defaults, arguments[0]);
	}

	var module = {};
	var that = this;

	graph.setAccessToken(this.options.accessToken);

	module.getEvents = function (onSuccess, onError) {

		graph.get(that.options.entityId + "?fields=events", function (err, resp) {
			if (err) {
				onError && onError(err);
				return;
			}
			onSuccess && onSuccess(resp);
		});
	};

	module.getLiveStream = function (onSuccess, onError) {

		graph.get(that.options.entityId + "/live_videos?fields=embed_html,id,status,description,broadcast_start_time", function (err, resp) {
			if (err) {
				onError && onError(err);
				return;
			}
			onSuccess && onSuccess(resp);
		});
	};

	module.getSingleEvent = function (eventId, onSuccess, onError) {

		graph.get(eventId, function (err, resp) {
			if (err) {
				onError && onError(err);
				return;
			}
			onSuccess && onSuccess(resp);
		});
	};

	module.getEventPicture = function (eventId, onSuccess, onError) {
		graph.get(eventId + "?fields=cover", function (err, resp) {
			if (err) {
				onError && onError(err);
				return;
			}
			onSuccess && onSuccess(resp);
		});
	};

	var refreshAccessToken = function refreshAccessToken() {
		graph.extendAccessToken({
			//"access_token":   that.options.accessToken,
			"client_id": that.options.appId,
			"client_secret": that.options.appSecret
		}, function (err, facebookRes) {

			//if(err)
			//	console.log(err);

			console.log(facebookRes);
		});
	};

	return module;
};

module.exports = facebookProvider;