'use strict';

require('babel-polyfill');

var appFactory = require('./serverAppFactory');

var KokoServer = function KokoServer(config) {
  var module = {};

  var app = new appFactory(config).createExpressApp();

  module.startServer = function () {

    var PORT = process.env.PORT || 4000;

    // Why don't I need http createServer
    app.listen(PORT, function () {
      console.log('App listening on port ' + PORT + '!');
    });
    app.on('error', onError);

    function onError(error) {
      if (error.syscall !== 'listen') {
        throw error;
      }

      var bind = typeof port === 'string' ? 'Pipe ' + port : 'Port ' + port;

      // handle specific listen errors with friendly messages
      switch (error.code) {
        case 'EACCES':
          console.error(bind + ' requires elevated privileges');
          process.exit(1);
          break;
        case 'EADDRINUSE':
          console.error(bind + ' is already in use');
          process.exit(1);
          break;
        default:
          throw error;
      }
    }
  };

  return module;
};

module.exports = KokoServer;