'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

//original base code which this is derived from can be found here
//https://github.com/ayroblu/ssr-cra-v2.1

var path = require('path');
var fs = require('fs');
var os = require('os');

var universalLoader = function universalLoader(config) {

  // this does most of the heavy lifting
  var serverRender = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, htmlData, initialStore) {
      var context, store, markup, RenderedApp;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:

              console.log(htmlData);

              //hack to temprorarly define browser globals on the serer
              if (!process.env.BROWSER) {
                global.window = {
                  location: {
                    protocol: req.protocol,
                    hostname: os.hostname()
                  }
                };
                global.document = { createElement: function createElement() {} };
              }

              context = { data: {}, head: [], req: req };
              store = config.storeConfigurator(initialStore || null);

              //render the app

              markup = config.renderer(req, store, context);


              if (context.url) {
                console.log("server renderrrrrrr 1");
                // Somewhere a `<Redirect>` was rendered
                res.redirect(301, context.url);
              } else {

                console.log(context);
                // we're good, add in markup, send the response
                RenderedApp = htmlData.replace('{{SSR}}', markup).replace('<meta-head/>', context.head).replace('<muicss/>', '<style id=\'server-side-styles\' >' + context.muiCss + '</style>').replace('{{data}}', new Buffer(JSON.stringify(store.getState())).toString('base64'));


                if (context.code) res.status(context.code);

                res.send(RenderedApp);
              }

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function serverRender(_x, _x2, _x3, _x4) {
      return _ref.apply(this, arguments);
    };
  }();

  var module = {};

  return function universalLoader(req, res) {
    var filePath = config.indexLocation;

    //console.log("got a request   " + req.originalUrl);

    fs.readFile(filePath, 'utf8', function (err, htmlData) {
      //console.log('read file');
      if (err) {
        console.error('read err', err);
        return res.status(404).end();
      }

      if (config.initialStoreFetcher) {
        //if we have an initial store state retriever get that first
        config.initialStoreFetcher(config, function (initialStore) {
          serverRender(req, res, htmlData, initialStore).catch(function (err) {
            console.error('Render Error', err);
            return res.status(500).json({ message: 'Render Error: ' + err });
          });
        });
      } else {
        //otherwise just render
        serverRender(req, res, htmlData).catch(function (err) {
          console.error('Render Error', err);
          return res.status(500).json({ message: 'Render Error: ' + err });
        });
      }
    });
  };
};

module.exports = universalLoader;